﻿// Copyright (C) 2008 - 2010 CASIO Europe GmbH
//
// This file is part of SoftkeysWM.
//
// SoftkeysWM is provided AS IS for educational purposes only,
// with no warranties, and confers no rights. Error checking is 
// elided for clarity. Carry out sufficient tests prior to using
// it in a productive environment.
// CASIO Europe GmbH accepts no responsibility for loss or damage
// arising from its use, including damage from virus.
//
// Please, note: This configuration information may be changed
// without any further notice.
// Casio Europe GmbH does not guarantee future compatibility. By 
// using this software you agree to these terms and conditions.
//
// System Requirements: Windows Mobile 6.5 Professional (IT-800)
///////////////////////////////////////////////////////////////////

using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Calib;

namespace PhoneKeysDisableWM
{
    /// <summary>
    /// This samples shows how to assign new key codes.
    /// </summary>
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Closing(object sender, CancelEventArgs e)
        {
            int result;

            ConfigureKeys(false);

            // Disable any user settings.
            result = SystemLibNet.Api.SysSetUserDefineKeyState(false);
        }

        private void ConfigureKeys(bool init)
        {
            int result;

            if (init == true)
            {
                int[] keyBufferF3 = new int[16];
                int[] keyBufferF4 = new int[16];

                for (short i = SystemLibNet.Def.KEY_MODE_NUM; i <= SystemLibNet.Def.KEY_MODE_ALPHAS; i++)
                {
                    result = SystemLibNet.Api.SysSetUserDefineKey(
                        i,
                        SystemLibNet.Def.KEYID_F3,
                        keyBufferF3);

                    result = SystemLibNet.Api.SysSetUserDefineKey(
                        i,
                        SystemLibNet.Def.KEYID_F4,
                        keyBufferF4);
                }

                result = SystemLibNet.Api.SysSetFnKeyLock(true);
            }
            else
            {
                for (short i = SystemLibNet.Def.KEY_MODE_NUM; i <= SystemLibNet.Def.KEY_MODE_ALPHAS; i++)
                {
                    result = SystemLibNet.Api.SysDeleteUserDefineKeyEx(
                        i,
                        SystemLibNet.Def.KEYID_F3);

                    result = SystemLibNet.Api.SysDeleteUserDefineKeyEx(
                        i,
                        SystemLibNet.Def.KEYID_F4);
                }

                result = SystemLibNet.Api.SysSetFnKeyLock(false);
            }

            // Inform the keyboard driver about changes.
            result = SystemLibNet.Api.SysSetUserDefineKeyState(true);
        }

        private void menuEnable_Click(object sender, EventArgs e)
        {
            ConfigureKeys(false);
            this.statusBar.Text = "F3 & F4 enabled.";
        }

        private void menuDisable_Click(object sender, EventArgs e)
        {
            ConfigureKeys(true);
            this.statusBar.Text = "F3 & F4 disabled.";
        }
    }
}